'' VECTORJET v0.0
'' (C)2020 IRQsome Software
'' Display list helper

VAR
  long head ' current write position
  long left ' how much space left
  long link ' last list link word
PUB start(ptr,size)
  head := ptr
  left := size
  link := $8080

PUB putlink
  word[link] := head
  link := head
  putword(0)

PUB putlong(x)
  if (left -= 4) < 0
    abort 1
  'if head & 3
    'abort 2
  long[head] := x
  head += 4

PUB putword(x)
  if (left -= 2) < 0
    abort 3
  'if head & 1
    'abort 4
  word[head] := x
  head += 2

PUB putbyte(x)
  if (--left) < 0
    abort 5
  byte[head++] := x

PUB slopeCalc(x1,x2,y1,y2)

  return ((x1-x2))/(y1.word[1]-y2.word[1])

PUB triangle(x1,y1,x2,y2,x3,y3,colors) | tmp,tmp2

if y1 > y2
  tmp := y1
  y1 := y2
  y2 := tmp
  
  tmp := x1
  x1 := x2
  x2 := tmp
  
if y1 > y3
  tmp := y1
  y1 := y3
  y3 := tmp
  
  tmp := x1
  x1 := x3
  x3 := tmp
  
if y2 > y3
  tmp := y2
  y2 := y3
  y3 := tmp
  
  tmp := x2
  x2 := x3
  x3 := tmp

putlink
putword(y1.word[1]) ' start line
putword(y3.word[1]) ' end line
putword(-1) ' init sync to -1
putbyte(1) ' type
putbyte(0) ' unused
putword(0) ' unused

if y2~>16 == y3~>16 ' bottom flat?
  'pst.str(string("bottom flat",13)) 
  repeat 2
    putlong(0)
  putlong(x1-$8000)
  putlong(x1+$8000)

  putword((y3.word[1])-(y1.word[1]))
  putword(colors)
  if x2 > x3
    'putlong((x3-x1)~>12*($1000_0000/(y3-y1)))
    'putlong((x2-x1)~>12*($1000_0000/(y2-y1))) 
    'putlong((x3-x1)**binRatio(1,(y3-y1)))
    'putlong((x2-x1)**binRatio(1,(y2-y1)))
    'putlong((((x3-x1))/((y3-y1)~>8))<<8)
    'putlong((((x2-x1))/((y2-y1)~>8))<<8)
    putlong(slopeCalc(x3,x1,y3,y1))
    putlong(slopeCalc(x2,x1,y2,y1))
  else
    'putlong((x2-x1)~>12*($1000_0000/(y2-y1)))
    'putlong((x3-x1)~>12*($1000_0000/(y3-y1)))
    'putlong((x2-x1)**binRatio(1,(y2-y1)))
    'putlong((x3-x1)**binRatio(1,(y3-y1)))
    'putlong((((x2-x1))/((y2-y1)~>8))<<8)
    'putlong((((x3-x1))/((y3-y1)~>8))<<8) 
    putlong(slopeCalc(x2,x1,y2,y1))
    putlong(slopeCalc(x3,x1,y3,y1)) 
  'putlong(-$10000)
  'putlong( $10000)

elseif y1~>16 == y2~>16 ' top flat?
  'pst.str(string("top flat",13))
  repeat 2
    putlong(0)
  if x1 > x2
    putlong(x2)
    putlong(x1)
  else
    putlong(x1)
    putlong(x2)
    
  putword((y3.word[1])-(y1.word[1]))
  putword(colors)

  
  if x1 > x2                               
    'putlong((x3-x2)~>12*($1000_0000/(y3-y2)))
    'putlong((x3-x1)~>12*($1000_0000/(y3-y1)))
    'putlong((((x3-x2))/((y3-y2)~>8))<<8)
    'putlong((((x3-x1))/((y3-y1)~>8))<<8)
    putlong(slopeCalc(x3-$8000,x2,y3,y2))
    putlong(slopeCalc(x3+$8000,x1,y3,y1))
  else                                     
    'putlong((x3-x1)~>12*($1000_0000/(y3-y1)))
    'putlong((x3-x2)~>12*($1000_0000/(y3-y2)))
    'putlong((((x3-x1))/((y3-y1)~>8))<<8)
    'putlong((((x3-x2))/((y3-y2)~>8))<<8)
    putlong(slopeCalc(x3-$8000,x1,y3,y1))
    putlong(slopeCalc(x3+$8000,x2,y3,y2))
   
   'putlong(0)
   'putlong(0)
else
  'pst.str(string("other",13))
  repeat 2
    putlong(0)
  putlong(x1-$8000)
  putlong(x1+$8000)

  putword((y2.word[1])-(y1.word[1])+1)
  putword(colors)

  'tmp := (((x3-x1))/((y3-y1)~>8))<<8 ' long slope
  'tmp := (x3-x1)~>12*($1000_0000/(y3-y1)) ' long slope
  tmp := slopeCalc(x3,x1,y3+$10000,y1) ' long slope
  tmp2 := slopeCalc(x2,x1,y2+$10000,y1)' short slope
  if tmp2 > tmp
    putlong(tmp)
    'putlong((((x2-x1))/((y2-y1)~>8))<<8)
    'putlong( inv := ( (x2-x1)~>12*($1000_0000/(y2-y1))) )
    'putlong(slopeCalc(x2-x1,y2-y1+$10000))
    'putlong(slopeCalc(x2-x1,(y2.word[1]-y1.word[1]+$1)<<16))
    putlong(tmp2)
    'pst.hex(inv,8)
  else
    'putlong((((x2-x1))/((y2-y1)~>8))<<8)
    'putlong( inv := ( (x2-x1)~>12*($1000_0000/(y2-y1)) ) )
    'putlong(slopeCalc(x2-x1,y2-y1+$10000))
    'putlong(slopeCalc(x2-x1,(y2.word[1]-y1.word[1]+$1)<<16))
    putlong(tmp2)  
    'pst.hex(inv,8) 
    putlong(tmp) 
  'putlong(-$10000)
  'putlong( $10000)
  
  putword((y3.word[1])-(y2.word[1])-1)
  putword(colors)

  
  if tmp2 > tmp
    putlong(tmp)
    'putlong((((x3-x2))/((y3-y2)~>8))<<8)
    'putlong((x3-x2)~>12*($1000_0000/(y3-y2))) 
    putlong(slopeCalc(x3,x2,y3,y2-$10000)) 
  else
    'putlong((((x3-x2))/((y3-y2)~>8))<<8)
    'putlong((x3-x2)~>12*($1000_0000/(y3-y2)))
    putlong(slopeCalc(x3,x2,y3,y2-$10000))
    putlong(tmp)    
  
  'putlong( $10000)
  'putlong(-$10000)

  